class GEN0081 {
	NiceName Generated_TCP_Lookalike;
	Compressed_ID 0x0081;
	UnCompressed_ID 0x0083;
	Parameter maxslots, ipcp_type = u_char, uput=PUTCHAR, uget=GETCHAR, size=1, ioctlname=PPPIOCSMAXGEN0081SLOT, pmin=2, pmax=16, pdefault=16;

	PField protover, fsize=4, ptype=NOCHANGE; 
	PField hdrlen, fsize=4, ptype=NOCHANGE;

	PField tos, fsize=8, ptype=NOCHANGE;
	PField totlen, fsize=16, ptype=INFERRED, formula=[length], checkformula=false;
	PField packetid, fsize=16, ptype=DELTA, encoding=TWOBYTE, negatives=DISALLOWED;
	PField fragments, fsize=16, ptype=NOCHANGE;
	PField ttl, fsize=8, ptype=NOCHANGE;
	PField prot, fsize=8, ptype=NOCHANGE;
	PField IPchecksum, fsize= 16, ptype=RANDOM;
	PField sourceIP, fsize=32, ptype=NOCHANGE;
	PField destIP, fsize=32, ptype=NOCHANGE;

	PField TCPsourcePort, fsize=16, ptype=NOCHANGE;
	PField TCPdestPort, fsize=16, ptype=NOCHANGE;
	PField TCPsequenceno, fsize=32, ptype=DELTA, encoding=VARONETHREE, negatives=DISALLOWED;
	PField TCPACKNo, fsize=32, ptype=DELTA, encoding=VARONETHREE, negatives=DISALLOWED;

	PComment pcomment; # the stuff below 
	PField TCPhdrlen, fsize=4, ptype=NOCHANGE;
	PField TCPreserved, fsize=6, ptype=NOCHANGE;
	PField URGflag, fsize=1, ptype=INFERRED, formula=[%UrgPointer], checkformula=true;
	PField ACKflag, fsize=1, ptype=RANDOM; # better performance than [%TCPACKNo]
	PField PSHflag, fsize=1, ptype=RANDOM;
	PField RSTflag, fsize=1, ptype=INFERRED, formula=0, checkformula=false;
	PField SYNflag, fsize=1, ptype=INFERRED, formula=0, checkformula=false;
	PField FINflag, fsize=1, ptype=INFERRED, formula=0, checkformula=false;

	PField WindowSize, fsize=16, ptype=DELTA, encoding=VARONETHREE, negatives=DISALLOWED;
	PField TCPchecksum, fsize=16, ptype=RANDOM;
	PField UrgPointer, fsize=16, ptype=DELTA, encoding=VARONETHREE, negatives=DISALLOWED;

	PFlag DetailedDebugMessages, status=off; # set to on or off

	PRule SendAsIP, ruletext=[protover]!=4; # want IP version 4
	PRule SendAsIP, ruletext=[hdrlen]<5; # don't handle IP options yet
	PRule SendAsIP, ruletext=[prot]!=6; # make sure it's TCP (proto#6)
	Prule SendAsIP, ruletext=[fragments]&0x3fff; # don't send fragments
	PRule SendAsIP, ruletext=[SYNflag]!=0; # don't send SYN/FIN/RST packets
	PRule SendAsIP, ruletext=[FINflag]!=0; # don't send these
	PRule SendAsIP, ruletext=[RSTflag]!=0; # don't send these

        PComment WhenSendAsIP, actiontext=PrintDebugMessage("Sent as IP\n");
        PComment WhenSendReference, actiontext=PrintDebugMessage("Sent reference packet\n");
        PComment WhenSendCompressed, actiontext=PrintDebugMessage("Sent compressed packet\n");

        PVarField IPOptions,$ruletext=[hdrlen]>5,$sizetext=([hdrlen]-5)*4,$maxsize=54,$starttext=4*5;
}
